<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cuponera StructType
 * @subpackage Structs
 */
class Cuponera extends AbstractStructBase
{
    /**
     * The cantidadCuotasCuponera
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $cantidadCuotasCuponera;
    /**
     * The diaPagoCuponera
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $diaPagoCuponera;
    /**
     * The fechaPrimerPagoCuponera
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $fechaPrimerPagoCuponera;
    /**
     * The montoCuponera
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $montoCuponera;
    /**
     * The tasaInteresCuponera
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $tasaInteresCuponera;
    /**
     * Constructor method for cuponera
     * @uses Cuponera::setCantidadCuotasCuponera()
     * @uses Cuponera::setDiaPagoCuponera()
     * @uses Cuponera::setFechaPrimerPagoCuponera()
     * @uses Cuponera::setMontoCuponera()
     * @uses Cuponera::setTasaInteresCuponera()
     * @param int $cantidadCuotasCuponera
     * @param int $diaPagoCuponera
     * @param int $fechaPrimerPagoCuponera
     * @param float $montoCuponera
     * @param float $tasaInteresCuponera
     */
    public function __construct($cantidadCuotasCuponera = null, $diaPagoCuponera = null, $fechaPrimerPagoCuponera = null, $montoCuponera = null, $tasaInteresCuponera = null)
    {
        $this
            ->setCantidadCuotasCuponera($cantidadCuotasCuponera)
            ->setDiaPagoCuponera($diaPagoCuponera)
            ->setFechaPrimerPagoCuponera($fechaPrimerPagoCuponera)
            ->setMontoCuponera($montoCuponera)
            ->setTasaInteresCuponera($tasaInteresCuponera);
    }
    /**
     * Get cantidadCuotasCuponera value
     * @return int|null
     */
    public function getCantidadCuotasCuponera()
    {
        return $this->cantidadCuotasCuponera;
    }
    /**
     * Set cantidadCuotasCuponera value
     * @param int $cantidadCuotasCuponera
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public function setCantidadCuotasCuponera($cantidadCuotasCuponera = null)
    {
        // validation for constraint: int
        if (!is_null($cantidadCuotasCuponera) && !(is_int($cantidadCuotasCuponera) || ctype_digit($cantidadCuotasCuponera))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cantidadCuotasCuponera, true), gettype($cantidadCuotasCuponera)), __LINE__);
        }
        $this->cantidadCuotasCuponera = $cantidadCuotasCuponera;
        return $this;
    }
    /**
     * Get diaPagoCuponera value
     * @return int|null
     */
    public function getDiaPagoCuponera()
    {
        return $this->diaPagoCuponera;
    }
    /**
     * Set diaPagoCuponera value
     * @param int $diaPagoCuponera
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public function setDiaPagoCuponera($diaPagoCuponera = null)
    {
        // validation for constraint: int
        if (!is_null($diaPagoCuponera) && !(is_int($diaPagoCuponera) || ctype_digit($diaPagoCuponera))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($diaPagoCuponera, true), gettype($diaPagoCuponera)), __LINE__);
        }
        $this->diaPagoCuponera = $diaPagoCuponera;
        return $this;
    }
    /**
     * Get fechaPrimerPagoCuponera value
     * @return int|null
     */
    public function getFechaPrimerPagoCuponera()
    {
        return $this->fechaPrimerPagoCuponera;
    }
    /**
     * Set fechaPrimerPagoCuponera value
     * @param int $fechaPrimerPagoCuponera
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public function setFechaPrimerPagoCuponera($fechaPrimerPagoCuponera = null)
    {
        // validation for constraint: int
        if (!is_null($fechaPrimerPagoCuponera) && !(is_int($fechaPrimerPagoCuponera) || ctype_digit($fechaPrimerPagoCuponera))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fechaPrimerPagoCuponera, true), gettype($fechaPrimerPagoCuponera)), __LINE__);
        }
        $this->fechaPrimerPagoCuponera = $fechaPrimerPagoCuponera;
        return $this;
    }
    /**
     * Get montoCuponera value
     * @return float|null
     */
    public function getMontoCuponera()
    {
        return $this->montoCuponera;
    }
    /**
     * Set montoCuponera value
     * @param float $montoCuponera
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public function setMontoCuponera($montoCuponera = null)
    {
        // validation for constraint: float
        if (!is_null($montoCuponera) && !(is_float($montoCuponera) || is_numeric($montoCuponera))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($montoCuponera, true), gettype($montoCuponera)), __LINE__);
        }
        $this->montoCuponera = $montoCuponera;
        return $this;
    }
    /**
     * Get tasaInteresCuponera value
     * @return float|null
     */
    public function getTasaInteresCuponera()
    {
        return $this->tasaInteresCuponera;
    }
    /**
     * Set tasaInteresCuponera value
     * @param float $tasaInteresCuponera
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public function setTasaInteresCuponera($tasaInteresCuponera = null)
    {
        // validation for constraint: float
        if (!is_null($tasaInteresCuponera) && !(is_float($tasaInteresCuponera) || is_numeric($tasaInteresCuponera))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($tasaInteresCuponera, true), gettype($tasaInteresCuponera)), __LINE__);
        }
        $this->tasaInteresCuponera = $tasaInteresCuponera;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\Cuponera
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
