<?php

namespace Liberty\Services\Emisor\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for detalleResponse StructType
 * @subpackage Structs
 */
class DetalleResponse extends AbstractStructBase
{
    /**
     * The codigo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $codigo;
    /**
     * The mensaje
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mensaje;
    /**
     * Constructor method for detalleResponse
     * @uses DetalleResponse::setCodigo()
     * @uses DetalleResponse::setMensaje()
     * @param int $codigo
     * @param string $mensaje
     */
    public function __construct($codigo = null, $mensaje = null)
    {
        $this
            ->setCodigo($codigo)
            ->setMensaje($mensaje);
    }
    /**
     * Get codigo value
     * @return int|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param int $codigo
     * @return \Liberty\Services\Emisor\StructType\DetalleResponse
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: int
        if (!is_null($codigo) && !(is_int($codigo) || ctype_digit($codigo))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get mensaje value
     * @return string|null
     */
    public function getMensaje()
    {
        return $this->mensaje;
    }
    /**
     * Set mensaje value
     * @param string $mensaje
     * @return \Liberty\Services\Emisor\StructType\DetalleResponse
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        $this->mensaje = $mensaje;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Liberty\Services\Emisor\StructType\DetalleResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
